Last Comment Bug 701987 - Remove checkbox for add-on auto-checking for updates (extensions.update.enabled) from the options window, and make enabling extensions.update.autoUpdateDefault in the add-ons manager also enable extensions.update.enabled.
: Remove checkbox for add-on auto-checking for updates (extensions.update.enabl...
Status: RESOLVED FIXED
:
Product: Firefox
Classification: Client Software
Component: Preferences (show other bugs)
: 10 Branch
: All All
: -- normal (vote)
: Firefox 11
Assigned To: Steffen Wilberg
:
Mentors:
Depends on:
Blocks: 600505 710064
  Show dependency treegraph
 
Reported: 2011-11-11 23:13 PST by al_9x
Modified: 2011-12-12 16:39 PST (History)
11 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
screenshot of the options window with the checkbox removed (40.43 KB, image/png)
2011-11-15 12:35 PST, Steffen Wilberg
jboriss: ui‑review+
Details
patch (6.02 KB, patch)
2011-11-15 12:48 PST, Steffen Wilberg
dtownsend: review+
Details | Diff | Splinter Review
string removals (for moz-central only) (1.37 KB, patch)
2011-11-15 12:56 PST, Steffen Wilberg
dtownsend: review+
Details | Diff | Splinter Review

Description al_9x 2011-11-11 23:13:51 PST
https://groups.google.com/group/mozilla.dev.apps.firefox/browse_thread/thread/d302eea559084d34

The options dialog has an "Automatically Update: Add-ons" checkbox.

The add-ons manager has an "Update Add-ons Automatically" check menu.

That these are different settings and how they are different is
unclear.  The first one controls automatic checking and should be titled
something like "Auto check for add-on updates."  The second, controls auto
installation after detection and should be titled something like "Auto
install detected updates."  And ideally, they should appear next to each other.
Comment 1 Steffen Wilberg 2011-11-14 13:09:39 PST
Bah, I made the change in bug 600505 (already on Aurora/10), not knowing about the second pref. :-(
Apart from reorganizing the app update pref UI, I did this:
-Automatically check for updates to: Add-ons
+Automatically update: Add-ons

That's misleading as its pref (extensions.update.enabled pref) only toggles *checking* for updates. If it finds updates, it will highlight them in the add-ons manager. It will not even prompt the user (that's bug 591189).

I wonder whether we still need that pref at all. Who would disable it? 
In the rapid release world, wouldn't people at least want to *know* that there's an update (or version bump) available, once they open the add-ons manager?

So we could make this checkbox toggle the pref extensions.update.autoUpdateDefault instead. "Update Add-ons automatically" currently lives in the "gears" menu of the add-ons manager and was introduced by bug 586574. CC'ing folks from that.
Comment 2 al_9x 2011-11-14 14:23:03 PST
(In reply to Steffen Wilberg from comment #1)
> I wonder whether we still need that pref at all. Who would disable it? 

Yes, you need it.  In some cases you want no checking whatsoever: subjective preference for manual checking, testing/troubleshooting profiles that should not update and issue any unsolicited background traffic, avoiding unsolicited triggering of on-demand dial-up connection, privacy/trust reasons (any app that does not allow one to disable phone home connections is acting suspiciously), etc. 

The purpose of this bug is not to eliminate the auto check pref but to title it appropriately so as to disambiguate it from the auto apply pref.
Comment 3 Dave Townsend [:mossop] 2011-11-14 14:36:44 PST
(In reply to al_9x from comment #2)
> (In reply to Steffen Wilberg from comment #1)
> > I wonder whether we still need that pref at all. Who would disable it? 
> 
> Yes, you need it.  In some cases you want no checking whatsoever

I'd agree we need a pref for it, though I'm inclined to think that we probably don't need it in the main UI anymore.

Either way the update settings are overly complex for the add-ons manager, we need to figure out what use cases we actually want to support and simplify things.
Comment 4 Jennifer Morrow [:Boriss] (UX) 2011-11-14 16:21:03 PST
(In reply to Steffen Wilberg from comment #1)
> I wonder whether we still need that pref at all. Who would disable it? 

I believe the history of this was that when automatic add-on update installation was first added and enabled by default, there was some outcry that the check from a user's profile against what add-on updates were available would be potentially identifiable itself.  If this pref is little used at this point, it may well fall under the "the world has changed" category, and simply getting rid of the pref item would be fine.  As far as I know, there's still an about:config items for this (can anyone verify?), and in the rapid-release world I wonder if anyone would really care about add-on update checks when Firefox itself is being updated so often.

So, my 2 cents is with Comment 1 - this pref is relic of Firefox 4 and no longer relevant.  And, with the preference in the add-ons manager to automatically update add-ons, it's also potentially confusing.  Let's simply remove it.

(In reply to al_9x from comment #2)
> (In reply to Steffen Wilberg from comment #1)
> > I wonder whether we still need that pref at all. Who would disable it? 
> 
> Yes, you need it.  In some cases you want no checking whatsoever: subjective
> preference for manual checking, testing/troubleshooting profiles that should
> not update and issue any unsolicited background traffic, avoiding
> unsolicited triggering of on-demand dial-up connection, privacy/trust
> reasons (any app that does not allow one to disable phone home connections
> is acting suspiciously), etc. 

Considering you can turn automatic add-on updating off in preference of manual updating, is there a truly compelling case to include in main preferences the ability to turn off even checking?
Comment 5 al_9x 2011-11-14 17:31:14 PST
(In reply to Jennifer Morrow [:Boriss] (Firefox UX) from comment #4)
> (In reply to al_9x from comment #2)
> > (In reply to Steffen Wilberg from comment #1)
> > > I wonder whether we still need that pref at all. Who would disable it? 
> > 
> > Yes, you need it.  In some cases you want no checking whatsoever: subjective
> > preference for manual checking, testing/troubleshooting profiles that should
> > not update and issue any unsolicited background traffic, avoiding
> > unsolicited triggering of on-demand dial-up connection, privacy/trust
> > reasons (any app that does not allow one to disable phone home connections
> > is acting suspiciously), etc. 
> 
> Considering you can turn automatic add-on updating off in preference of
> manual updating, is there a truly compelling case to include in main
> preferences the ability to turn off even checking?

You are arguing for dumping just the UI not the underlying pref, right?  As long as the underlying pref remains, loss of the UI is manageable, but I would like to point out that the current confusion can be eliminated without removing the UI.

There is nothing inherently complex or confusing about the concepts of auto checking for updates and auto installing detected updates.  The confusion stems from poor placement and the naming of the settings.  If they were arranged next to each other and named according to what they actually control:

[x] Auto check for add-on updates
[x] Auto install detected updates

as opposed to 2 ambiguous, identically named "auto update add-ons" settings in different locations, there wouldn't be any confusion.
Comment 6 Steffen Wilberg 2011-11-15 01:21:06 PST
(In reply to Jennifer Morrow [:Boriss] (Firefox UX) from comment #4)
> As far as
> I know, there's still an about:config items for this (can anyone verify?),
The "extensions.update.enabled" pref is always present in about:config, defaulting to true.

> So, my 2 cents is with Comment 1 - this pref is relic of Firefox 4 and no
> longer relevant.  And, with the preference in the add-ons manager to
> automatically update add-ons, it's also potentially confusing.  Let's simply
> remove it.

(In reply to Dave Townsend (:Mossop) from comment #3)
> I'd agree we need a pref for it, though I'm inclined to think that we
> probably don't need it in the main UI anymore.
OK, will do.

I'd also suggest a change to the "gears" menu of the add-ons manger: If the user enables "Update Add-ons automatically" (extensions.update.autoUpdateDefault), we should also enable the "check for add-on updates" (extensions.update.enabled) pref (in cmd_toggleAutoUpdateDefault), because we can't automatically update without having checked for updates first.
Comment 7 Steffen Wilberg 2011-11-15 12:35:37 PST
Created attachment 574654 [details]
screenshot of the options window with the checkbox removed
Comment 8 Steffen Wilberg 2011-11-15 12:48:10 PST
Created attachment 574656 [details] [diff] [review]
patch
Comment 9 Steffen Wilberg 2011-11-15 12:56:52 PST
Created attachment 574659 [details] [diff] [review]
string removals (for moz-central only)
Comment 10 Pete Boyd 2011-11-16 07:21:57 PST
(In reply to Steffen Wilberg from comment #1)
> I wonder whether we still need that pref at all. Who would disable it? 

We deploy various add-ons (Zotero, Zotero OpenOffice plugin, Adblock Plus, the British English dictionary) to all our deployments of Firefox at all our clients, on a system-wide basis rather than a per-user basis. We control when new versions of those add-ons are automatically deployed and so want the ability for people not to be nagged about updates and not to have those updates automatically try to update.
Comment 11 Steffen Wilberg 2011-11-16 08:21:33 PST
Sure. Your admin can still toggle those prefs in about:config, I'm just removing the checkbox to do that from the options window.
Comment 12 Pete Boyd 2011-11-16 08:33:03 PST
I am that admin. I just wanted to add an answer to the question "Who would disable it?" because my angle hadn't been covered and it seemed quite a sweeping statement being made by the question, is all.
Comment 13 Dave Townsend [:mossop] 2011-11-29 15:03:22 PST
Comment on attachment 574656 [details] [diff] [review]
patch

Dropping from my review queue until we have agreement from UX on this.
Comment 14 Dave Townsend [:mossop] 2011-11-29 15:03:41 PST
Comment on attachment 574659 [details] [diff] [review]
string removals (for moz-central only)

Dropping from my review queue until we have agreement from UX on this.
Comment 15 Dave Townsend [:mossop] 2011-12-08 11:59:18 PST
Comment on attachment 574656 [details] [diff] [review]
patch

Review of attachment 574656 [details] [diff] [review]:
-----------------------------------------------------------------

::: toolkit/mozapps/extensions/content/extensions.js
@@ +760,5 @@
>          } catch(e) { }
> +        var newValue = !oldValue; // toggle
> +        Services.prefs.setBoolPref(PREF_AUTOUPDATE_DEFAULT, newValue);
> +
> +        // If trhe user wants us to auto-update add-ons, we also need to

Correct this typo
Comment 16 Dave Townsend [:mossop] 2011-12-08 11:59:57 PST
Comment on attachment 574659 [details] [diff] [review]
string removals (for moz-central only)

Review of attachment 574659 [details] [diff] [review]:
-----------------------------------------------------------------

I wouldn't expect these changes to go to aurora at this point anyway.
Comment 17 Steffen Wilberg 2011-12-11 00:00:27 PST
Changing summary to what the patch does.
Comment 18 Rimas Kudelis 2011-12-12 13:48:27 PST
Wouldn't it make more sense to leave the checkbox, but make it toggle exactly the same preferences as that gears menu item? This way, all update-related checkboxes would be kept in one place, and all add-on related prefs would also be available in add-on manager. Having two ways to do something doesn't always hurt IMO.
Comment 19 Steffen Wilberg 2011-12-12 14:46:21 PST
Pushed both patches as one changeset, with typo fixed:
http://hg.mozilla.org/mozilla-central/rev/6057abf8f4e6

Note You need to log in before you can comment on or make changes to this bug.